package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopMerchantApplyService;
import com.gxwebsoft.shop.entity.ShopMerchantApply;
import com.gxwebsoft.shop.param.ShopMerchantApplyParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商户入驻申请控制器
 *
 * @author 科技小王子
 * @since 2024-10-02 08:08:23
 */
@Api(tags = "商户入驻申请管理")
@RestController
@RequestMapping("/api/shop/shop-merchant-apply")
public class ShopMerchantApplyController extends BaseController {
    @Resource
    private ShopMerchantApplyService shopMerchantApplyService;

    @ApiOperation("分页查询商户入驻申请")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopMerchantApply>> page(ShopMerchantApplyParam param) {
        // 使用关联查询
        return success(shopMerchantApplyService.pageRel(param));
    }

    @ApiOperation("查询全部商户入驻申请")
    @GetMapping()
    public ApiResult<List<ShopMerchantApply>> list(ShopMerchantApplyParam param) {
        // 使用关联查询
        return success(shopMerchantApplyService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopMerchantApply:list')")
    @OperationLog
    @ApiOperation("根据id查询商户入驻申请")
    @GetMapping("/{id}")
    public ApiResult<ShopMerchantApply> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(shopMerchantApplyService.getByIdRel(id));
    }

    @ApiOperation("添加商户入驻申请")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopMerchantApply shopMerchantApply) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          shopMerchantApply.setUserId(loginUser.getUserId());
        }
        if (shopMerchantApplyService.save(shopMerchantApply)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商户入驻申请")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopMerchantApply shopMerchantApply) {
        if (shopMerchantApplyService.updateById(shopMerchantApply)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商户入驻申请")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopMerchantApplyService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商户入驻申请")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopMerchantApply> list) {
        if (shopMerchantApplyService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商户入驻申请")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopMerchantApply> batchParam) {
        if (batchParam.update(shopMerchantApplyService, "apply_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商户入驻申请")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopMerchantApplyService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
